package eu.mhsl.minecraft.pixelblocks.pixelblock;

import eu.mhsl.minecraft.pixelblocks.Main;
import org.bukkit.Location;
import org.bukkit.NamespacedKey;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Interaction;
import org.bukkit.persistence.PersistentDataType;

import java.util.List;
import java.util.Objects;

public class PixelBlockHitbox {
    private static final NamespacedKey hitboxOfTag = new NamespacedKey(Main.plugin(), "hitbox_of");

    private final PixelBlock parentBlock;

    public PixelBlockHitbox(PixelBlock parentBlock) {
        this.parentBlock = parentBlock;
    }

    public void spawn() {
        Location absoluteLocation = this.parentBlock.getPixelBlockLocation();
        List<PixelBlockWorld.PixelData> pixels = this.parentBlock.getPixelData();
        float offset = (float) Main.configuration().hitboxOffset();
        int pixelsPerBlock = Main.configuration().pixelsPerBlock();

        Interaction interaction;
        if (pixels.size() <= 5 || true) {
            interaction = (Interaction) absoluteLocation.getWorld().spawnEntity(
                absoluteLocation.clone().add(0.5, -offset, 0.5),
                EntityType.INTERACTION
            );
            interaction.setInteractionHeight(1 + 2 * offset);
            interaction.setInteractionWidth(1 + 2 * offset);
        } else {
//            double startingX = absoluteLocation.x() + MinMaxUtil.getMinProperty(pixels, pixel -> pixel.relativeLocation().getX());
//            double startingY = absoluteLocation.y() + MinMaxUtil.getMinProperty(pixels, pixel -> pixel.relativeLocation().getY());
//            double startingZ = absoluteLocation.z() + MinMaxUtil.getMinProperty(pixels, pixel -> pixel.relativeLocation().getZ());
//
//            double endingX = absoluteLocation.x() + MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.relativeLocation().getX());
//            double endingY = absoluteLocation.y() + MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.relativeLocation().getY());
//            double endingZ = absoluteLocation.z() + MinMaxUtil.getMaxProperty(pixels, pixel -> pixel.relativeLocation().getZ());
//
//            Location spawnLocation = absoluteLocation.clone().add(
//                ((startingX+endingX+1)/2)/pixelsPerBlock,
//                ((startingY+endingY+1)/2)/pixelsPerBlock,
//                ((startingZ+endingZ+1)/2)/pixelsPerBlock
//            );

//            float height = (float) (endingY-startingY+1)/pixelsPerBlock + 2*offset;
//
//            float width;
//            if((endingX-startingX) > (endingZ-startingZ)) {
//                width = (float) (endingX-startingX+1)/pixelsPerBlock + 2*offset;
//            } else {
//                width = (float) (endingZ-startingZ+1)/pixelsPerBlock + 2*offset;
//            }
//
//            if(spawnLocation.getX()+width/2 > pixelBlockLocation.getX()+1) {
//                spawnLocation.subtract((spawnLocation.getX()+width/2)-(pixelBlockLocation.getX()+1), 0, 0);
//            }
//            if(spawnLocation.getX()-width/2 < pixelBlockLocation.getX()) {
//                spawnLocation.add(pixelBlockLocation.getX()-(spawnLocation.getX()-width/2), 0, 0);
//            }
//
//            if(spawnLocation.getZ()+width/2 > pixelBlockLocation.getZ()+1) {
//                spawnLocation.subtract(0, 0, (spawnLocation.getZ()+width/2)-(pixelBlockLocation.getZ()+1));
//            }
//            if(spawnLocation.getZ()-width/2 < pixelBlockLocation.getZ()) {
//                spawnLocation.add(0, 0, pixelBlockLocation.getZ()-(spawnLocation.getZ()-width/2));
//            }

//            interaction = (Interaction) absoluteLocation.getWorld().spawnEntity(
//                spawnLocation,
//                EntityType.INTERACTION
//            );
//
//            interaction.setInteractionHeight(0.5f);
//            interaction.setInteractionWidth(0.5f);
        }

        interaction.getPersistentDataContainer()
            .set(hitboxOfTag, PersistentDataType.STRING, this.parentBlock.getBlockUUID().toString());
    }


    public void destroy() {
        this.parentBlock.getPixelBlockLocation().getNearbyEntitiesByType(Interaction.class, 1)
            .stream()
            .filter(interaction -> interaction.getPersistentDataContainer().has(hitboxOfTag))
            .filter(interaction -> Objects.equals(
                interaction.getPersistentDataContainer().get(hitboxOfTag, PersistentDataType.STRING),
                parentBlock.getBlockUUID().toString()
            ))
            .forEach(Entity::remove);
    }
}
